#!/usr/bin/perl
BEGIN {
    eval "use Nmap::Scanner";
    if ( $@ ) {
        warn  "Error to load module: Nmap::Scanner\n"
        . "Install Module:\n"        
        . "\t\tcpan\n"
        . "\t\tcpan> install Nmap::Scanner\n";
exit ();
 }
}
use POSIX qw(strftime);
$hora= strftime("%Y-%m-%d", localtime);
if ( @ARGV != 2 ) {
    die "\nUse: $0 <hosts.txt> <report.html>\n\n"
      . "   hosts.txt    File that contains de ip addresses to audit\n"
      . "   report.html File which will show the final report based on the audit\n\n"
      ;
}
my $scanner = new Nmap::Scanner;
$scanner->guess_os();
$scanner->register_scan_complete_event(\&scan_complete);
$scanner->register_scan_started_event(\&scan_started);
$scanner->register_port_found_event(\&port_found);
my $lista = $ARGV[0];
my $file = $ARGV[1];
my $opciones_scan = "-sS -sU -A -vv -iL $lista -oX -";
$antes = time(); 
open (F,">> $file");
print F "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Transitional//EN'
'htp://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'>\n";
print F "<html xmlns=http://www.w3.org/1999/xhtml>\n<head>\n";
print F "<meta http-equiv=Content-Type content='text/html;charset=iso-8859-1' />\n";
print F "<title>Nmap Report $hora Red: $lista</title>\n";
print F "<!-- Script created by situ: marcos(at)mmgonline.com.ar with help from perlenespanol forum-->";
print F "</head>\n";
print F "<body>\n";
print F " <table border='0' align=center width=700 cellpadding='0' cellspacing='0' bgcolor=#e6e6fa>\n";
print F "  <tr>\n";
print F "   <td><img src='logo.gif'></td>\n";
print F "   <td><strong>Date:</strong> $hora <br>\n";
print F "       <strong>Options Nmap:</strong> $opciones_scan<br>\n";
print F "       <strong>Hosts:</strong> $lista<br>\n";
print F "       <strong>Characteristics: </strong><font color=#F3C035 face=Verdana size=1>host </font>- <font color=#00ff00 face=Verdana size=1>active </font>- <font color=#ff0000 face=Verdana size=1>no responds </font>- <font color=#00ff00 face=Verdana size=1>open </font>- <font color=#ff0000 face=Verdana size=1>close </font>- <font color=#6666ff face=Verdana size=1>tcp </font>- <font color=#666600 face=Verdana size=1>udp</font>";
print F "   </td>\n";
print F "  </tr>\n";
print F " </table>\n";
print F " <table border='0' align=center width=700 cellpadding='0' cellspacing='0' bgcolor=#f2f2f2>\n";
$scanner->scan($opciones_scan);
print F " </table>\n";
print F "</body>\n</html>\n";
sub scan_started {
        my $self     = shift;
        my $host     = shift;
        $hostname = $host->hostname();
        $addresses = join(',', map {$_->addr()} $host->addresses());
        my $status = $host->status();
if ($status eq  "up"){$estado="<font face=Verdana size=1 color=#00ff00>Active</font>\n";}
        elsif($status eq "down"){$estado="<font face=Verdana size=1 color=#ff0000>No responds</font>\n";}
        print F "  <tr>\n";
        print F "  <tr>\n";
        print F "   <td bgcolor=#848484>\n <font color=#F3C035 face=Verdana size=1>$hostname ($addresses)</font> $estado\</td>\n";
        print F "  </tr>\n";

}

sub port_found {
        my $self     = shift;
        my $host     = shift;
        my $port     = shift;
        no warnings;
        my $name = $host->hostname();
        my $puerto = $port->state();
        if ($puerto eq "open"){$pestado="<font color=#00ff00>open</font>";}
        elsif($puerto eq "closed"){     $pestado="<font color=#ff0000>closed</font>";}
        my $proto= $port->protocol();
        if ($proto eq "tcp"){$protoc="<font color=#6666ff>tcp</font>";}
        elsif($proto eq "udp"){$protoc="<font color=#666600>udp</font>";}          
        my $hola = join(' ',$pestado,$protoc,$port->portid(),$port->service()->name(),$port->service()->version());
        print F "  <tr><td><font face=Verdana size=1>$hola</font></td></tr>\n";
}

sub scan_complete {

    my $self = shift;
    my $host = shift;
no warnings;
	print F "  <tr><td bgcolor=#c0c0c0> <font face=Verdana size=1>";
	print F "Host Descripcion:\n<br>";
   for my $match ($host->os()->osmatches()) {
        print F "Host could be of type: " . $match->name(),"\n<br>";

    }


    for my $c ($host->os()->osclasses()) {
	print F "* " . $c->vendor() . "\n";
        print F"- OS generation: " . $c->osgen() . "\n<br>";
        print F"- OS family:     " . $c->osfamily() . "\n<br>";
        print F"- OS Type:       " . $c->type() . "\n<br>";
    }

        print F "Host has been up since " . $host->os->uptime()->lastboot()."\n"
            if defined $host->os()->uptime();

print F "  </font></tr></td>";

}
		
$duracion = time() - $antes;

print F " <table border='0' align=center width=700 cellpadding='0' cellspacing='0' bgcolor=#646464>\n";
print F "  <tr>\n";
print F "   <td><font color=#000000 face=Verdana size=1>Time to ejecution: $duracion seconds</font>\n";
print F "   </td>\n";
print F "  </tr>\n";
print F " </table>\n";
close (F);

